Subject: bug#67925: 29.1; delete-rectangle fails on multi-column characters

From: Eli Zaretskii <[email-masked]>
Date: Fri, 22 Dec 2023 13:45:56 +0200

> From: Juri Linkov <[email-masked]>
> Cc: [email-masked],  Stefan Monnier <[email-masked]>,
>   Stefan Kangas <[email-masked]>,  [email-masked]
> Date: Fri, 22 Dec 2023 09:56:20 +0200
> 
> >> >> This patch gives similar result of kill-rectangle.
> >> >> In the example above, I want all '4' characters moved to same column.
> >> >
> >> > How can that be done, when the first character takes 2 or more
> >> > columns?  Deleting the first character is IMO wrong, since the other
> >> > lines leave the first character intact.  Adding SPC to other lines is
> >> > also wrong, since delete-rectangle is not supposed to _add_ columns.
> >>
> >> I think wide characters may be replaced with SPC like TAB.
> >
> > I don't think I agree.  Let's see what others think Stefan, Juri,
> > Stefan, any opinions?  Does anyone else have an opinion on this?
> 
> Does the same problem exist for deleting rectangles in texts
> with a variable-pitch font?  If you draw a vertical line
> it will cross a lot of characters in the middle.

No, since columns still count correctly, as long as Emacs considers
all characters to be of the same single-column width.  IOW, the
rectangle commands work by columns, not by pixel-coordinates.